//+------------------------------------------------------------------+
/////////////CYCLE TRIANGULAR CENTERED END-POINT  
//////////////Sohocool March 2012

//|                                       
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
 
 
#property  indicator_separate_window
#property  indicator_buffers 4
#property indicator_color1 LawnGreen
#property indicator_color2 Red
#property  indicator_color3  Blue
#property  indicator_color4  Red
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 1
#property indicator_width4 1


//---- indicator parameters
extern string TimeFrame = "Current time frame";
extern int Fast_HalfLength=24;    
extern int Slow_HalfLength=48;
extern int PRICE = 5; 
//extern int SignalSMA=1;

//---- indicator buffers
double     ind_Buffer1[];
double     ind_Buffer2[];
double     ind_buffer3a[];
double     ind_buffer3b[];
double     ind_buffer4[];
double     ind_buffer5[];
double slope[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(7);
//---- drawing settings
double SignalSMA =1;

   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexDrawBegin(0,SignalSMA);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexDrawBegin(1,SignalSMA);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexBuffer(4,ind_Buffer1);
   SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(5,ind_Buffer2);
   SetIndexBuffer(6,slope);
   
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
   
//---- 5 indicator buffers mapping
   if(!SetIndexBuffer(0,ind_buffer3a) &&
      !SetIndexBuffer(1,ind_buffer3b) &&
      !SetIndexBuffer(2,ind_buffer4) &&      
      !SetIndexBuffer(3,ind_buffer5) &&
      !SetIndexBuffer(4,ind_Buffer1) &&      
      !SetIndexBuffer(5,ind_Buffer2))
      Print("cannot set indicator buffers!");
//---- name for DataWindow and indicator subwindow label

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";     if (returnBars) { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
               
   IndicatorShortName(timeFrameToString(timeFrame)+" Cycle Tma End-Point  ("+Fast_HalfLength+","+Slow_HalfLength+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ind_buffer3a[0] = MathMin(limit+1,Bars-1); return(0); }
         if (timeFrame!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));

   for(int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         ind_buffer4[i]  = iMA(NULL,timeFrame,Fast_HalfLength+1,0,3,PRICE,y)-iMA(NULL,timeFrame,Slow_HalfLength+1,0,3,PRICE,y);
         ind_buffer3a[i] = EMPTY_VALUE;
         ind_buffer3b[i] = EMPTY_VALUE;      
         slope[i]        = slope[i+1];
            if (ind_buffer4[i]>ind_buffer4[i+1]) slope[i] =  1;
            if (ind_buffer4[i]<ind_buffer4[i+1]) slope[i] = -1;
            if (slope[i]== 1) ind_buffer3a[i]=ind_buffer4[i];
            if (slope[i]==-1) ind_buffer3b[i]=ind_buffer4[i];
      }   
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}